
//  T2.13_Persons in firm.cpp
/* " ",    Visual Studio 6.0, 
    Visual Studio.Net 2005.  . - .  . */

#include <fstream>           //    
#include <iostream>    
#include <string> 

using namespace std; 

struct person                //    person
       {char name[20];
        int age;
       };

int menu(void)
{int iz;
 cout << endl;
 cout << "\n*******************  MENU   ****************************";
 cout << "\n* 1. Enter or add person!   ****************************";
 cout << "\n* 2. Display a list of persons!   **********************";
 cout << "\n* 3. Enter a number of records!   **********************";
 cout << "\n* 4. Information for persons under 30 years!   *********";
 cout << "\n* 5. Changing a name of person!   **********************";
 cout << "\n* 6. End program!   ************************************";
 do{
    cout << "\n\n Please enter your choice - from  1 to 6: ";
    cin >> iz;
    cout << "\n Your choice is: " << iz;
   }while(iz<1 || iz>6);
 return iz;
}

void write_to_text_file(person p_Data)  //     
{fstream t_file("test13.dat", ios::out | ios::app);
 if (!t_file)
  {cout << "\n Error at opening the file for write!"; return;}
 else
   {t_file.write((char *)(&p_Data), sizeof(struct person));
    t_file.close();}
} //      write_to_text_file()

void read_from_text_file()              //     
{person p_Data; 
 cout << "\n\n --- Searching in the file ---"  << endl;
 fstream t_file("test13.dat", ios::in);
 if(!t_file) 
  {cout << "\n Error at opening the file for searching!"; return;}
 t_file.seekg(0L, ios::end);
 long int length = t_file.tellg();
 t_file.seekg(0L, ios::beg); 
 if(length==0) 
  {cout << "\n The file is empty!!! \n"; return;}
else                                //      - 
  {t_file.read((char *)(&p_Data), sizeof(person));
   while(!t_file.eof()) 
   {cout << " Name: " << p_Data.name << endl;
    cout << " Age: " << p_Data.age << endl;
    t_file.read((char *)(&p_Data), sizeof(person));
   }
   t_file.close();
  } //  -      
} //      read_from_text_file()

//        -  
void search_from_text_file()         //    
{person p_Data; 
 cout << "\n\n --- Searching in the file ---"  << endl;
 fstream t_file("test13.dat", ios::in);
 if(!t_file) 
  {cout << "\n Error at opening the file for searching!"; return;}
 t_file.seekg(0L, ios::end);
 long int length = t_file.tellg();
 t_file.seekg(0L, ios::beg); 
 if(length==0) 
  {cout << "\n The file is empty!!! \n"; return;} 
 else                               //     
 {long int records = length/sizeof(person);
//     - records
  cout << "\n Choose a number of record";
  cout << "\n from 1 to " << records << ": ";
  long int numb; cin >> numb;       //    
  if(numb>0 && numb<=records)       //     
   {numb--;       //        0
    t_file.seekg((numb * sizeof(struct person)), ios::beg);
    t_file.read((char *)(&p_Data),sizeof(person));
    cout << " Name: " << p_Data.name << endl;
    cout << " Age: " << p_Data.age << endl;
    t_file.close();
   } 
  else                              //      
  cout << "\n The number must to be between 1 and " << records << endl;
 }
} //    search_from_text_file()

//       30 
void search_less_than_30()
{person p_Data;
 cout<<"\n\n --- Information for persons under 30 years ---"<< "\n\n";
 fstream t_file("test13.dat",ios::in);
 if(!t_file)
 {cout << "\n Error at opening the file for information!"; return;}
  t_file.seekg(0L, ios::end);
  long int length = t_file.tellg();
  t_file.seekg(0L, ios::beg);
  if(length==0) {cout << "\n The file is empty!!! \n"; return;}
  else                              //     
  {t_file.read((char *)(&p_Data),sizeof(person));
   while(!t_file.eof()) 
    {if(p_Data.age<30)
     {cout << " Name: " << p_Data.name << endl;
      cout << " Age: " << p_Data.age << endl;}
      t_file.read((char *)(&p_Data),sizeof(person));
    }
   t_file.close();
  } //  -      
} //    search_less_than_30() 

//     ,     
void search_name_from_text_file()
{long int pos; person buf;
 char change_name[10]; //   
 bool flag=false;      // flag=false,      
 person p_Data;
 fstream t_file("test13.dat", ios::in);
 if(!t_file)
  {cout << "\n Error at opening the file for read!"; return;}
   t_file.seekg (0L, ios::end);
   long int length = t_file.tellg(); // length -   
   t_file.seekg(0L, ios::beg);
   if(length==0) 
    {cout<<"\n The file is empty!!! \n"; return;}
   else                              //    
    {cout << "\n Enter a name for change: "; cin >> change_name;
     fstream t_2("test13.dat", ios::out|ios::in);
     while(!t_file.eof())
     {t_file.read((char *)(&p_Data),sizeof(person));
      if(t_file.eof()) break;
      if(strcmp(p_Data.name,change_name)==0)
       {flag=true;     //     
                       //    pos    
        pos= (long)t_file.tellg() - sizeof(p_Data);
        t_2.seekg(pos, ios::beg); 
        cout << "\n Enter new name:"; cin >> buf.name;
        cout << "\n Enter new age:"; cin >> buf.age;
        t_2.write((char *)(&buf),sizeof(struct person));
       } 
     }
    if(!flag) 
     cout<<"\n Name " << change_name << " is not unavailable!!!";
    t_2.close();
    } //     
   t_file.close();
} //    search_name_from_text_file()  

int main(void)
{person p; int izbor;
 do{
    izbor=menu();
    switch(izbor)
    {case 1: cout << "\n Please, enter a name: "; cin >> p.name;
           cout <<"\n Please, enter the age of " << p.name << ": ";
           cin >> p.age;
           write_to_text_file(p);break;
     case 2: read_from_text_file();break;
     case 3: search_from_text_file();break;
     case 4: search_less_than_30(); break;
     case 5: search_name_from_text_file();break; 
     default: cout<<"\n\t\t *** End of the progran! *** \n\n";
    } //   case
   } while(izbor!=6);
} //   main()




