

//  T2.8_Peek and putback.cpp

//     peek()  putback().
//         ( 
// ),       (   
// ),       

#include <iostream>
#include <fstream>
#include <cctype>
using namespace std;

int main()
{ 
  char ch;
  ofstream out("test2.txt", ios::out | ios::binary);

  if(!out) {
    cout << "Cannot open output file.\n";
    return 1;
  }

  char str[80], *p;
 
  cout << "\nWrite data to file test2.txt ...\n";
  out << 123 << "this is a test" << 23;
  out << "Hello there!" << 99 << "sdf" << endl;
  out.close();
  
  ifstream in("test2.txt", ios::in | ios::binary);

  if(!in) {
    cout << "Cannot open input file.\n";
    return 1;
  }

  cout << "\nRead data from file test2.txt: \n";
  do {
    p = str;
    ch = in.peek();     //       
    if(isdigit(ch)) {
      while(isdigit(*p=in.get())) p++;       //   
      in.putback(*p);                        //  char  
      *p = '\0';                   //     null 
      cout << "Integer: " << atoi(str);
    }
    else if(isalpha(ch)) {                   //   
      while(isalpha(*p=in.get())) p++;
      in.putback(*p);                        //  char  
      *p = '\0';                   //     null
      cout << "String: " << str;
    }
    else in.get();                 // 
    cout << '\n';
  } while(!in.eof());
  
  in.close();

  system("pause");
  return 0;
}
