
//  T2.9_Read and write.cpp

//      :
// write(), read()  gcount() -    .

#include <iostream>
#include <fstream>
using namespace std;

int main()
{
  ofstream out("test2A.txt", ios::out | ios::binary);

  if(!out) {
    cout << "Cannot open output file.\n";
    return 1;
  }

  double nums[4] = {1.1, 2.2, 3.3, 4.4 };

  cout << "\nWrite data to file test2A.txt ...\n";
  out.write((char *) nums, sizeof(nums));
  out.close();

  ifstream in("test2A.txt", ios::in | ios::binary);

  if(!in) {
    cout << "Cannot open input file.\n";
    return 1;
  }

  cout << "\nRead data from file test2A.txt: \n";
  in.read((char *) &nums, sizeof(nums));

  int i;
  for(i=0; i<4; i++) 
    cout << nums[i] << ' ';

  cout << '\n';

  cout << in.gcount() << " characters read\n";
  in.close();
  cout << endl;

  system("pause");
  return 0;
}
