//      .
//  T2_Airport file_Self.cpp.   Dev-C++ 4.9.9.2.     32  .
// :  , .  61172355,  6 . 13.12.2017

/*   C++       -  .
       :
   -         ( )    ( 30) -  : 
;   ;   ;   1 ;   2 ; 
   1 ;    2  ( ). 
  -      ()  ;
  -           .
  
    main() -            . 
*/

/*      -  struct    7 .  
      :     ()   .
     3      (  )
       ,   .
        (  )      .
              
     .
           .
      -   , , 
     .
   
       7 . 
               ,
            ( ),
   -  ,    .
*/


#include <iostream>
#include <cstring>
#include <fstream>
#include <iomanip>

using namespace std;

const char Name[] = "poleti.txt"; //   

struct airport //    
{
	char day[10]; //      
	char flightnum[30]; //   
	char Pilotname[30]; //   
	char passangers1[250]; //   1 
	char passangers2[250]; // 2 
	int ticketprice1; //    1 
	int ticketprice2; //  2 
};

fstream fp; //      

void create(airport st[]) //       
{
	int i, n; //2   
	do
	{
		cout << "\n How many flights do you want to register? : "; //   
		cin >> n;//     
	} while //         30
		(n<1 || n>30); //
	fp.open(Name, ios::binary | ios::out | ios::app);//        
	if (!fp) { //     
		{cout << "\n Error: File does not exist!"; _sleep(2000); exit(1);//    	 
        }
	}
	for (i = 0; i<n; i++) //       
	{
		fflush(stdin); //  
		cout << "\n Day of flight: "; cin >> st[i].day; //    
		cout << "\n Pilot name: "; cin.ignore(); cin.getline (st[i].Pilotname,80);//  
		cout << "\n Flight number: "; cin >> st[i].flightnum;//  
		cout << "\n Number of passangers first class: "; cin >> st[i].passangers1;//  1 
		cout << "\n Number of passangers second class: "; cin >> st[i].passangers2;//  2 
		cout << "\n First class ticket price: $ "; cin >> st[i].ticketprice1;//   1 
		cout << "\n Second class ticket price: $ "; cin >> st[i].ticketprice2;//  2 
	}
	fp.write((char*)st, n*sizeof(airport));//   
	fp.close();// 
}

void output(airport st[]) //       
{
	int i, n;// 2   
	long pos;//       
	airport s;//   
	cout << "\n List of flights \n";// 
	fp.open(Name, ios::binary | ios::in);//      
	if (!fp) {//     
		{cout << "\n Error: File does not exist!"; _sleep(2000); exit(1);//    		 
        }
		
	}
	fp.seekg(0L, ios::end);//        

	pos = fp.tellg(); n = pos / sizeof(airport);//   
	fp.seekg(0L, ios::beg);//  
	for (i = 0; i<n; i++)//    
	{
		fp.read((char*)&s, sizeof(airport));//  
		st[i] = s;//     
		cout << i + 1 << "\n Day: " << st[i].day << " \n Pilot Name: " 
             << st[i].Pilotname << "\n Flight Number: " << st[i].flightnum 
             << "\n 1st Class Passangers: " << st[i].passangers1 << "\n 2nd Class Passangers:";
		cout << st[i].passangers2 << " \n 1st Class Ticket Price:$ " 
        << st[i].ticketprice1 << "\n Second class ticket price:$ " << st[i].ticketprice2 << endl;
		//  
	}
	fp.close();// 
}

void searchname(airport st[]) //       
{
	int i, n;//2    
	int k = 0;//        
	long pos;//      
	airport s;//   
	char name[10];//  
	cout << "\n Search for pilot: ";// 
	cin >> name;// 
	fp.open(Name, ios::binary | ios::in);//     
	if (!fp) {//    
		{cout << "\n Error: File does not exist!"; _sleep(2000); exit(1);//     
        }
	}
	fp.seekg(0L, ios::end);//    

	pos = fp.tellg(); n = pos / sizeof(airport);//   
	fp.seekg(0L, ios::beg);// 
	for (i = 0; i<n; i++)//  
	{
		fp.read((char*)&s, sizeof(airport));// 
		st[i] = s;//   
		if (strcmp(st[i].Pilotname, name) == 0)//    
		{
			cout << i + 1 << "\n Day: " << st[i].day << "\n Pilot Name: " << st[i].Pilotname << "\n Flight Number: " << st[i].flightnum << " \n 1st Class Passangers: " << st[i].passangers1 << "\n 2nd Class Passangers:";
			cout << st[i].passangers2 << " \n 1st Class Ticket Price:$ " << st[i].ticketprice1 << "\n Second class ticket price:$ " << st[i].ticketprice2 << endl;
			k++; //  
		}

	}
	if (k == 0)// 
		cout << "\n No such flight";//    
	fp.close();// 
}

int main() //  
{
	int ch;//  
	struct airport st[30];//   30  
	do {
		cout << "\n *** Varna Airport Flight Schedule ***";
		cout << "\n 1.Register a flight";
		cout << "\n 2.List all flights";
		cout << "\n 3.Track a pilot's flight";
		cout << "\n 4.Exit";
		do
		{
			cout << "\n\n Your choice: "; cin >> ch;
		}

		while (ch<1 || ch>4);
		switch (ch)
		{
		case 1:create(st); break;
		case 2:output(st); break;
		case 3:searchname(st); break;
		}
	} while (ch != 4);
	
	cout << "\n\t Author: Alex Alexandrov, f. number 61172355, SIT 6b group. 13.12.2017 \n";
	_sleep(3000);
	
	return 0;
}
